/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder;


import org.freebuilder.system.ideengine.*;

import org.freebuilder.system.debug.Debug;


/** <code>FreeBuilder</code> class is the main class of the Free Builder.
  *
  * @author George Petkov <a href=mailto:pgeorge@mail.techno-link.com> pgeorge@mail.techno-link.com </a>,  
  * <a href=mailto:gpetkov@usa.net> gpetkov@usa.net</a>
  * @version 0.7, 02-12-97 */


public class Main {

  static  Main FBuilder    = null;

          IdeEngine   FIdeEngine;

  //Construct the application

  public Main() throws IdeException {

    FIdeEngine = new IdeEngine();

    FBuilder   = this;

  }


  public void Run() {

    FIdeEngine.WakeUp();

  }


  static public void main(String[] args) {

    try {

      Debug.isDebug = true;         // Set it true for testing version & false for final release

      FBuilder = new Main();

      FBuilder.Run();

    }

    catch(IdeException e) {

      System.out.println(e.getMessage());

    }

  }

}

