/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder.gui.ide;

import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.plaf.basic.*;

/**
  * @author	<a href=mailto:wreck@nat.bg> Peter Radkov </a>
    @version 0.7, 07-01-98
*/
class MySplitPaneUI extends BasicSplitPaneUI {
  private OptionsSetable Boss = null;
  private Divider TheDivider;
  public MySplitPaneUI (OptionsSetable Boss) {
    super();
    this.Boss = Boss;
    TheDivider = new Divider ();
  }

  protected void startDragging () {
    super.startDragging();
    TheDivider.setVisible (true);
  }

  protected void finishDraggingTo (int NewLoc) {
    super.finishDraggingTo (NewLoc);
    if (Boss != null)
      Boss.setNewOptions();
    TheDivider.setVisible (false);
  }

  public JSplitPane getSplitPane () {
    return splitPane;
  }

  protected Component createDefaultNonContinuousLayoutDivider() {
    return TheDivider;
  }
}

