/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder.gui.idemenu;

import java.util.EventObject;
import org.freebuilder.system.classes.events.engine.IdeEventListenerI;
import org.freebuilder.system.classes.events.engine.IdeSuperEvent;
import org.freebuilder.system.classes.events.MenuEventAdapter;

/** The class <code>MainMenuEventAdapter</code> will accept all the events of MainMenuEvent class
  *
  * @author	George Petkov <a href=mailto:pgeorge@mail.techno-link.com> pgeorge@mail.techno-link.com </a>,  <a href=mailto:gpetkov@usa.net> gpetkov@usa.net</a>
  * @version 0.7, 07-01-98 */

public class MainMenuEventAdapter extends MenuEventAdapter {

  public MainMenuEventAdapter(int AEventNumber, Object AMethodRef, String AMethodName)
    throws NoSuchMethodException, SecurityException {
    super(AEventNumber, IdeEventListenerI.CALL_MASK,  AMethodRef, AMethodName);
  }

  protected Class PrepareEventsClass() {
    MainMenuEvent Event = new MainMenuEvent(this);
    return Event.getClass();
  }

  public boolean AcceptEvent (IdeSuperEvent AEvent) {
    if (!super.AcceptEvent(AEvent))
      return false;
    return (((MainMenuEvent)AEvent).MenuSubCommand == MainMenuEvent.msubcDoIt);
  }
}
