/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder.system.classes.events.engine;

import org.freebuilder.system.debug.Debug;
import java.util.EventObject;

/** The class <code>NumberAdapter</code> creates the standart way for distinguish the events ( via number)
  * Override AcceptEvent method, which just compare two Event's numbers.
  *
  * @author	George Petkov <a href=mailto:pgeorge@mail.techno-link.com> pgeorge@mail.techno-link.com </a>,  <a href=mailto:gpetkov@usa.net> gpetkov@usa.net</a>
  * @version 0.7, 02-12-97 */
  
public class NumberAdapter extends MethodCallAdapter {
  int EventNumber;

  public NumberAdapter(int AEventNumber, int ACallMask,  Object AMethodRef, String AMethodName)
    throws NoSuchMethodException, SecurityException {

    super (ACallMask,  AMethodRef, AMethodName);
    EventNumber = AEventNumber;
  }

  public boolean AcceptEvent(IdeSuperEvent AEvent) {
    if (AEvent == null) return false;
    return ((NumberEvent)AEvent).EventID == EventNumber;
  }

  protected Class PrepareEventsClass() {
    NumberEvent Event = new NumberEvent(0, new EventObject(this));
    return Event.getClass();
  }

  protected int getEventNumber() { return EventNumber; }
}

