/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder.system.classes.options;

import java.util.EventObject;
import org.freebuilder.system.classes.events.engine.*;

/** Class <code>OptionsEvent</code>. When the options for any tool, or IDE has changed,
  * this kind of event will be possed. For the way of dispatching see <href>OptionsEventAdapter</href>.
  *
  * @author	George Petkov <a href=mailto:pgeorge@mail.techno-link.com> pgeorge@mail.techno-link.com </a>,  <a href=mailto:gpetkov@usa.net> gpetkov@usa.net</a>
  * @version 0.7, 02-12-97 */
  
public class OptionsEvent extends NumberEvent {
  final static public int msgOptionsRefresh       = 0;                       /** Set current options (After loading for example) */
  final static public int msgOptionsChanged       = msgOptionsRefresh  + 1;  /** Options have been changed */
  final static public int msgOptionsRemoveRequest = msgOptionsChanged + 1;  /** Can we remove the Options from OptionsColl ? */

  private OptionsSuperI Options;

  public OptionsEvent(int AEventID, EventObject Event, OptionsSuperI Options) {
    super(AEventID, Event);
    this.Options = Options;
  }

  public OptionsSuperI getOptions() { return Options; }
}
