/*
 * Copyright (c) 1998 Vanand Ltd.
 * <vanand@mail.techno-link.com>, <vanand@iname.com>, <a-hristov@usa.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package org.freebuilder.system.classes.options.manager;

import org.freebuilder.system.classes.options.*;

/** The interface <code>CreateDOptionsListener</code> gives a chance an instance of class
  * not inherited from OptionsColl to prepare All the Default Options for the program.
  * For example this can be a method of class IdeEngine.
  * This method is called every time the OptionsColl.CreateDefaultConfig() is called.
  *
  * @author	George Petkov <a href=mailto:pgeorge@mail.techno-link.com> pgeorge@mail.techno-link.com </a>,  <a href=mailto:gpetkov@usa.net> gpetkov@usa.net</a>
  * @version 0.7, 02-12-97 */

public interface CreateDOptionsListener {
  /** This method is called every time the DefaultOptions.CreateDefaultConfig() is called. */
  public void CreateDefaultConfig(OptionsColl AOptionsColl);
}
